function table.merge(t, x)
	tt = #t
	for i=1, #x do
		t[tt+i] = x[i]
	end
	return t
end

function pxlline(gc,y1,x1,y2,x2)
	gc:drawLine(x1,y1,x2,y2)
end

cy = 35
cx = 145

lns =	{90,90,15,70,15,70,cy,cx,cy,cx,90,90}
newlns = {}

itms = #lns/4

function flr(t, n, d) 
	rawset(t, n, math.floor(d))
	return t
end

function zT(t)
	t.mt = { __newindex = flr }
	setmetatable(t, t.mt)
	return t
end


function halfline(gc,y,x,yy,xx,it,iit)
	yy1 = y+((yy-y)/3)
	yy2 = y+(2*((yy-y)/3))
	xx1 = x+((xx-x)/3)
	xx2 = x+(2*((xx-x)/3))
	xl = xx2-xx1
	yl = yy2-yy1
	leng = math.sqrt(math.pow(xl,2)+math.pow(yl,2))
	h = math.sqrt(math.pow(leng,2)-math.pow((leng/2),2))
	xx0 = xx1+(xl/2)
	yy0 = yy1+(yl/2)
	cx = xx0+((h*yl)/leng)
	cy = yy0-((h*xl)/leng)
	if it==iit then
		pxlline(gc,yy1,xx1,cy,cx)
		pxlline(gc,yy2,xx2,cy,cx)
	else
		coords = zT{yy1,xx1,cy,cx,cy,cx,yy2,xx2,y,x,yy1,xx1,yy2,xx2,yy,xx}
	end
	
	newlns = table.merge(newlns, coords)
end

function on.paint(gc)
	for index=1,5 do
		itms = #lns/4
		for i=1,itms do
			dy1 = lns[i*4-3]
			dx1 = lns[1+i*4-3]
			dy2 = lns[2+i*4-3]
			dx2 = lns[3+i*4-3]
			gc:drawString(tostring(index),20,20*index+20)
			halfline(gc,dy1,dx1,dy2,dx2,5,index)
		end
		lns = newlns
		newlns = {}
	end
end
